#import "RNDFPBannerManager.h"
#import "RNDFPBannerView.h"

#if __has_include(<React/RCTBridge.h>)
#import <React/RCTBridge.h>
#else
#import "RCTBridge.h"
#endif

#import <React/RCTUIManager.h>

@implementation RNDFPBannerManager

RCT_EXPORT_MODULE();

- (UIView *)view
{
    return [[RNDFPBannerView alloc] init];
}

- (dispatch_queue_t)methodQueue
{
    return dispatch_get_main_queue();
}

RCT_EXPORT_VIEW_PROPERTY(adSizes, NSArray);
RCT_EXPORT_VIEW_PROPERTY(dimensions, NSDictionary);
RCT_EXPORT_VIEW_PROPERTY(bannerSize, NSString);
RCT_EXPORT_VIEW_PROPERTY(adUnitID, NSString);
RCT_EXPORT_VIEW_PROPERTY(testDeviceID, NSString);
RCT_EXPORT_VIEW_PROPERTY(targeting, NSDictionary);

RCT_EXPORT_VIEW_PROPERTY(onSizeChange, RCTBubblingEventBlock)
RCT_EXPORT_VIEW_PROPERTY(onAdmobDispatchAppEvent, RCTBubblingEventBlock)
RCT_EXPORT_VIEW_PROPERTY(onAdViewDidReceiveAd, RCTBubblingEventBlock)
RCT_EXPORT_VIEW_PROPERTY(onDidFailToReceiveAdWithError, RCTBubblingEventBlock)
RCT_EXPORT_VIEW_PROPERTY(onAdViewWillPresentScreen, RCTBubblingEventBlock)
RCT_EXPORT_VIEW_PROPERTY(onAdViewWillDismissScreen, RCTBubblingEventBlock)
RCT_EXPORT_VIEW_PROPERTY(onAdViewDidDismissScreen, RCTBubblingEventBlock)

RCT_EXPORT_METHOD(reloadBanner:(nonnull NSNumber *)reactTag)
{
  [self.bridge.uiManager addUIBlock:^(__unused RCTUIManager *uiManager, NSDictionary<NSNumber *, RNDFPBannerView *> *viewRegistry) {
    RNDFPBannerView *view = viewRegistry[reactTag];
    if (![view isKindOfClass:[RNDFPBannerView class]]) {
      RCTLogError(@"Invalid view returned from registry, expecting RNDFPBannerView, got: %@", view);
    } else {
      [view loadBanner];
    }
  }];
}

@end
